<?php
class JSONController extends Zend_Controller_Action
{
    function tasksAction ()
    {
        $this->getResponse()->setHeader('Content-type', 'text/json');
        $db = Zend::registry('dbController');
        $select = $db->select()->from('tasks', array("id" , "guid" , "admin_task" , "owner" , "task_status" , "task_percentage" , "last_run_time" , "next_run_time" , "last_completed_time"));
        $tasks = $db->fetchAll($select);
        $result = array();
        foreach ($tasks as $task) {
            if ($task["admin_task"] == "No") {
                $result[] = $task;
            } else {
                $unmodTask = $task;
                $select = $db->select()->from('task_status')->where('task_guid =?', $task["guid"]);
                $qresult = $db->fetchAll($select);
                if (count($qresult) == 0) {
                    $modTask = $unmodTask;
                    $modTask["task_status"] = "stopped";
                    $modTask["task_percentage"] = "0";
                    $modTask["owner"] = "";
                    $modTask["id"] = "";
                    $modTask["last_run_time"] = "Never.";
                    $modTask["last_completed_time"] = "Never.";
                    $modTask["next_run_time"] = "Never.";
                    $result[] = $modTask;
                } else {
                    foreach ($qresult as $res) {
                        $modTask = $unmodTask;
                        $modTask["task_status"] = $res["task_status"];
                        $modTask["task_percentage"] = $res["task_progress"];
                        $modTask["owner"] = $res["computer_guid"];
                        $modTask["id"] = ($res["sid"] + $unmodTask["id"]);
                        $modTask["last_run_time"] = $res["last_run_time"];
                        $modTask["last_completed_time"] = $res["last_completed_time"];
                        $modTask["next_run_time"] = $res["next_run_time"];
                        $result[] = $modTask;
                    }
                }
            }
        }
        echo (json_encode(array("result" => $result)));
    }
    function compQueueAction ()
    {
        $db = Zend::registry('dbController');
        switch ($_POST['computer_action']) {
            case 'resend':
                $computers = $_POST['selected_computers'];
                $cs = new Custom_ComputerSelect();
                foreach ($computers as $comp_id) {
                    $select = $db->select()->from('computers')->where('comp_guid = ?', $comp_id)->limit(1);
                    $compDetail = $db->fetchRow($select);
                    $tasks = $cs->getAdminTasks($compDetail['computer_name'], $compDetail['workgroup']);
                    if ($tasks === false) {
                        $row = array("comp_guid" => $compDetail['comp_guid'] , "cmd_name" => "REFRESH" , "status" => "pending" , "xml" => "");
                        $db->insert('cmdqueue', $row);
                    } else {
                        foreach ($tasks as $task) {
                            $row = array("comp_guid" => $compDetail['comp_guid'] , "cmd_name" => "REFRESH" , "status" => "pending" , "xml" => "" , "task_id" => $task['id']);
                            try {
                                $db->insert('cmdqueue', $row);
                            } catch (Exception $e) {
                                var_dump($e);
                            }
                        }
                    }
                }
                break;
        }
        echo ("<script>window.location.reload();</script>");
    }
    function clearQueueAction ()
    {
        $db = Zend::registry('dbController');
        $db->delete('cmdqueue');
        echo ("<script>window.location.reload();</script>");
    }
    function queueAction ()
    {
        $db = Zend::registry('dbController');
        switch ($_POST['task_action']) {
            case 'start':
                $tasks = $_POST['selected_tasks'];
                foreach ($tasks as $task_id) {
                    $cs = new Custom_ComputerSelect();
                    $children = $cs->getTaskComputers($task_id);
                    $taskGuid = $db->fetchCol('SELECT guid FROM tasks WHERE id = :id', array("id" => $task_id));
                    $taskName = $db->fetchCol('SELECT task_name FROM tasks WHERE id = :id', array("id" => $task_id));
                    $xml = "<serverCommand><name>TASK-START</name><tasks><task><taskName>" . htmlentities($taskName[0]) . "</taskName><taskID>$taskGuid[0]</taskID></task></tasks></serverCommand>";
                    foreach ($children as $child) {
                        $insertRow = array("comp_guid" => $child , "cmd_name" => "TASK_START" , "status" => "pending" , "xml" => $xml , "task_id" => $task_id);
                        $db->insert('cmdqueue', $insertRow);
                        Custom_TaskManagement::setTaskStatus($taskGuid[0], 'Starting', '0', $child);
                        //                        Logger::Log(2, 0, $taskGuid[0], $child);
                    }
                }
                break;
            case 'stop':
                $tasks = $_POST['selected_tasks'];
                foreach ($tasks as $task_id) {
                    $cs = new Custom_ComputerSelect();
                    $children = $cs->getTaskComputers($task_id);
                    try {
                        $taskGuid = $db->fetchCol('SELECT guid FROM tasks WHERE id = :id', array("id" => $task_id));
                        $taskName = $db->fetchCol('SELECT task_name FROM tasks WHERE id = :id', array("id" => $task_id));
                    } catch (Exception $e) {
                        var_dump($e);
                    }
                    $xml = "<serverCommand><name>TASK-STOP</name><tasks><task><taskName>" . htmlentities($taskName[0]) . "</taskName><taskID>$taskGuid[0]</taskID></task></tasks></serverCommand>";
                    foreach ($children as $child) {
                        $insertRow = array("comp_guid" => $child , "cmd_name" => "TASK_STOP" , "status" => "pending" , "xml" => $xml , "task_id" => $task_id);
                        $db->insert('cmdqueue', $insertRow);
                        Custom_TaskManagement::setTaskStatus($taskGuid[0], 'Stopping', '0', $child);
                        //                        Logger::Log(5, 0, $taskGuid[0], $child);
                    }
                }
                break;
            case 'restore':
                $tasks = $_POST['selected_tasks'];
                foreach ($tasks as $task_id) {
                    $cs = new Custom_ComputerSelect();
                    $children = $cs->getTaskComputers($task_id);
                    try {
                        $taskGuid = $db->fetchCol('SELECT guid FROM tasks WHERE id = :id', array("id" => $task_id));
                        $taskName = $db->fetchCol('SELECT task_name FROM tasks WHERE id = :id', array("id" => $task_id));
                    } catch (Exception $e) {
                        var_dump($e);
                    }
                    $xml = "<serverCommand><name>TASK-RESTORE</name><tasks><task><taskName>" . htmlentities($taskName[0]) . "</taskName><taskID>$taskGuid[0]</taskID></task></tasks></serverCommand>";
                    foreach ($children as $child) {
                        $insertRow = array("comp_guid" => $child , "cmd_name" => "TASK_RESTORE" , "status" => "pending" , "xml" => $xml , "task_id" => $task_id);
                        $db->insert('cmdqueue', $insertRow);
                        Custom_TaskManagement::setTaskStatus($taskGuid[0], 'Waiting Confirmation', '0', $child);
                        //                        Logger::Log(7, 0, $taskGuid[0], $child);
                    }
                }
                break;
        }
        if ($_POST['fromedit'] == false) {
            echo ("<script>window.location.reload();</script>");
        } else {
            echo ("<script>saveTabs();</script>");
        }
    }
    function checkNameAction ()
    {
        $db = Zend::registry('dbController');
        $name = $_GET['name'];
        $result = false;
        $select = $db->select()->from('tasks')->where('task_name = ?', $name)->where('task_hidden = ?', 'No');
        $result = ! ($db->fetchRow($select) ? true : false);
        echo (json_encode(array("result" => $result , "name" => $name)));
    }
    function squeueAction ()
    {
        $db = Zend::registry('dbController');
        $selectedTasks = $_POST['selected_tasks'];
        switch ($_POST['task_action']) {
            case 'start':
                foreach ($selectedTasks as $computer => $tasks) {
                    foreach ($tasks as $taskPos => $taskId) {
                        $taskGuid = $db->fetchCol('SELECT guid FROM tasks WHERE id = :id', array("id" => $taskId));
                        $taskName = $db->fetchCol('SELECT task_name FROM tasks WHERE id = :id', array("id" => $taskId));
                        $xml = "<serverCommand><name>TASK-START</name><tasks><task><taskName>" . htmlentities($taskName[0]) . "</taskName><taskID>$taskGuid[0]</taskID></task></tasks></serverCommand>";
                        $insertRow = array("comp_guid" => $computer , "cmd_name" => "TASK_START" , "status" => "pending" , "xml" => $xml , "task_id" => $taskId);
                        $db->insert('cmdqueue', $insertRow);
                        Custom_TaskManagement::setTaskStatus($taskGuid[0], 'Starting', '0', $computer);
                        //                        Logger::Log(2, 0, $taskGuid[0], $computer);
                    }
                }
                break;
            case 'stop':
                foreach ($selectedTasks as $computer => $tasks) {
                    foreach ($tasks as $taskPos => $taskId) {
                        $taskGuid = $db->fetchCol('SELECT guid FROM tasks WHERE id = :id', array("id" => $taskId));
                        $taskName = $db->fetchCol('SELECT task_name FROM tasks WHERE id = :id', array("id" => $taskId));
                        $xml = "<serverCommand><name>TASK-STOP</name><tasks><task><taskName>" . htmlentities($taskName[0]) . "</taskName><taskID>$taskGuid[0]</taskID></task></tasks></serverCommand>";
                        $insertRow = array("comp_guid" => $computer , "cmd_name" => "TASK_STOP" , "status" => "pending" , "xml" => $xml , "task_id" => $taskId);
                        $db->insert('cmdqueue', $insertRow);
                        //setTaskStatus($taskGuid[0], 'Stopping', '0', $computer);
                        Custom_TaskManagement::setTaskStatus($taskGuid[0], 'Stopping', '0', $computer);
                        //                        Logger::Log(5, 0, $taskGuid[0], $computer);
                    }
                }
                break;
            case 'restore':
                foreach ($selectedTasks as $computer => $tasks) {
                    foreach ($tasks as $taskPos => $taskId) {
                        $taskGuid = $db->fetchCol('SELECT guid FROM tasks WHERE id = :id', array("id" => $taskId));
                        $taskName = $db->fetchCol('SELECT task_name FROM tasks WHERE id = :id', array("id" => $taskId));
                        $xml = "<serverCommand><name>TASK-RESTORE</name><tasks><task><taskName>" . htmlentities($taskName[0]) . "</taskName><taskID>$taskGuid[0]</taskID></task></tasks></serverCommand>";
                        $insertRow = array("comp_guid" => $computer , "cmd_name" => "TASK_RESTORE" , "status" => "pending" , "xml" => $xml , "task_id" => $taskId);
                        $db->insert('cmdqueue', $insertRow);
                        Custom_TaskManagement::setTaskStatus($taskGuid[0], 'Waiting Confirmation', '0', $computer);
                        //                        Logger::Log(7, 0, $taskGuid[0], $computer);
                    }
                }
                break;
        }
    }
}