<?php
/**
 * Blank controller intended for management of the reports section
 * 
 * @author Nophinity
 * @version 0.0
 * @todo Finish it
 * @see Zend_Controller_Action
 * 
 */
class ReportsController extends Zend_Controller_Action
{
    /**
     * Main action to display list_reports.tpl
     *
     */
    var $defaultFilters = array("log_type" => - 1 , "status" => - 1 , "datefilter" => "All" , "date" => NULL , "sortby" => "time" , "sorttype" => "ASC" , "computer_search" => "" , "task_search" => "");
    var $statusResolve = array(0 => 'Success' , 1 => 'Warnings' , 2 => 'Errors' , 3 => 'Missed');
    function viewAction ()
    {
        $db = Zend::registry('dbController');
        $smarty = new Custom_Smarty('Reports', 'view_report.tpl', 'mainTemplate.tpl', 'reportsSubMenu.tpl');
        $logSelector = $db->select()->from('logs', array('logs.id AS logs_id' , 'logs.time' , 'logs.status' , 'logs.log_type_id' , 'tasks.task_name' , 'computers.computer_name' , 'log_types.name' , 'logs.summary' , 'logs.details' , 'tasks.id'));
        $logSelector->join("computers", "logs.computer_id = computers.comp_guid");
        $logSelector->join("tasks", "logs.task_id = tasks.guid");
        $logSelector->join("log_types", "log_types.id = logs.log_type_id");
        $id = $this->_getParam('report');
        $logSelector->where('logs.id = ?', $id);
        $logSelector->limit(1);
        try {
            $result = $db->fetchRow($logSelector);
        } catch (Exception $e) {
            echo ($logSelector);
            Zend::dump($e);
        }
        $smarty->assign('status', $this->statusResolve);
        $smarty->assign('details', $result);
        $smarty->dumpT();
    }
    function getReports ($uid, $smartyVars = NULL, $typeFilters = NULL, $statusFilters = NULL)
    {
        $smarty = new Custom_Smarty('Reports', 'list_reports.tpl', 'mainTemplate.tpl', 'reportsSubMenu.tpl');
        $db = Zend::registry('dbController');
        $name = $uid . 'filters';
        if ($_POST["Apply"] != "") {
            $_SESSION["$name"] = $_POST['filters'];
        }
        if ($_POST["Clear"] != "") {
            $_SESSION["$name"] = $this->defaultFilters;
            $_SESSION["$uuid"]['fromDate'] = "";
            $_SESSION["$uuid"]['toDate'] = "";
        }
        if (is_array($_SESSION["$name"]))
            $filters = $_SESSION["$name"]; else {
            $filters = $this->defaultFilters;
            $yesterday = strtotime('yesterday', time(0));
            $tomorrow = strtotime('tomorrow', time(0));
            $filters['fromDate'] = date("Y-m-d", $yesterday);
            $filters['toDate'] = date('Y-m-d', $tomorrow);
        }
        /* Get log types */
        $select = $db->select()->from('log_types');
        $logTypes = $db->fetchAssoc($select);
        $smarty->assign('logTypes', $logTypes);
        /* Get logs */
        $logSelector = $db->select()->from('logs', array('logs.id AS logs_id' , 'logs.time' , 'logs.status' , 'logs.log_type_id' , 'tasks.task_name' , 'computers.computer_name' , 'log_types.name' , 'tasks.id'));
        $logSelector->join("computers", "logs.computer_id = computers.comp_guid");
        $logSelector->join("tasks", "logs.task_id = tasks.guid");
        $logSelector->join("log_types", "log_types.id = logs.log_type_id");
        if ($typeFilters != NULL && is_array($typeFilters)) {
            foreach ($typeFilters as $sed) {
                foreach ($sed as $vType => $vValue) {
                    $logSelector->orWhere("$vType = ?", $vValue);
                }
            }
        }
        // Apply filters
        if ($filters['log_type'] != - 1)
            $logSelector->where('logs.log_type_id = ?', $filters['log_type']);
        if ($filters['status'] != - 1)
            $logSelector->where('logs.status = ?', $filters['status']);
        if ($filters['computer_search'] != "")
            $logSelector->where('computers.computer_name LIKE ?', "%$filters[computer_search]%");
        if ($filters['task_search'] != "")
            $logSelector->where('tasks.task_name LIKE ?', "%$filters[task_search]%");
        $fromDate = $filters['fromDate'];
        $toDate = $filters['toDate'];
        if ($fromDate != "") {
            $logSelector->where('logs.time >= ?', $fromDate);
        }
        if ($toDate != "") {
            $logSelector->where('logs.time <= ?', $toDate);
        }
        if ($filters['excluderescheduled'] === "true") {
            //$logSelector->where("STR_TO_DATE(tasks.next_run_time, '%m/%d/%Y %H:%i:%s') < logs.time");
            $logSelector->where('missed = ?', 'no');
            $logSelector->orWhere("tasks.next_run_time = 'Never.'");
        }
        if ($_GET['sortby'] != "") {
            $logSelector->order("$_GET[sortby] $_GET[sorttype]");
        } else {
            $logSelector->order("logs.time DESC");
        }
        $smarty->assign('sorttype', $_GET['sorttype'] == "ASC" ? "DESC" : "ASC");
        $smarty->assign('sortby', $_GET['sortby']);
        try {
            $logs = $db->fetchAll($logSelector);
        } catch (Exception $error) {
            Zend::dump($error);
            echo ($logSelector);
        }
        /* Make a computer list */
        $lComputers = $db->fetchAll("SELECT * FROM computers WHERE status = 'approved'");
        $lTasks = $db->fetchAll("SELECT * FROM tasks WHERE task_hidden = 'No'");
        if ($smartyVars != NULL && is_array($smartyVars)) {
            foreach ($smartyVars as $var => $value) {
                $smarty->assign("$var", $value);
            }
        }
        $smarty->assign('computers', $lComputers);
        $smarty->assign('tasks', $lTasks);
        $smarty->assign('filters', $filters);
        $smarty->assign('logs', $logs);
        $smarty->assign('status', $this->statusResolve);
        $smarty->dumpT();
        return $logSelector;
    }
    function IndexAction ()
    {
        $smartyVars = array();
        $this->getReports('logs', $smartyVars);
    }
    function allreportsAction ()
    {
        $smartyVars = array('reports' , 'hideFilterType' => true);
        $typeFilters[] = array('logs.log_type_id' => 4);
        $typeFilters[] = array('logs.log_type_id' => 7);
        $this->getReports($smartyVars, $typeFilters);
        return;
    }
    function warningsAction ()
    {
        $smartyVars = array('hideStatusFilter' => true);
        $typeFilters[] = array('logs.status' => 1);
        $typeFilters[] = array('logs.status' => 2);
        $this->getReports('warnings', $smartyVars, $typeFilters);
        return;
    }
    function missedAction ()
    {
        $smartyVars = array('hideFilterType' => true , 'hideStatusFilter' => true);
        $typeFilters[] = array('logs.log_type_id' => 10);
        $this->getReports('missed', $smartyVars, $typeFilters);
        return;
    }
}