<?php
/**
 * Blank controller intended for management of the xml backend
 * 
 * @author Nophinity
 * @version 0.0
 * @todo Finish it
 * @see Zend_Controller_Action
 * 
 */
define("ERROR_QUERY", "QUERY_ERROR");
define("ERROR_MESSAGE", "QUERY_MESSAGE");
define("ERROR_ATTRIBUTE", "QUERY_ATTRIBUTE");
class XmlController extends Zend_Controller_Action
{
    var $serverVersion = "2.0";
    var $clientRequiredVersion = "1.1";
    var $requestCommands = array("REQUEST-COMMAND" => "cmdRequest" , "USER-TASK-NEW" => "cmdTaskNew" , "USER-TASK-EDIT" => "cmdTaskEdit" , "USER-TASK-DELETE" => "cmdTaskDelete" , "TASK-STARTED" => "cmdTaskStart" , "TASK-PROGRESS" => "cmdTaskUpdate" , "TASK-ENDREPORT" => "cmdTaskEndReport" , "REGISTER-IN-SERVER" => "cmdRegister" , "TASK-RESTORE-RESPONSE" => "cmdRestoreResponse" , "REFRESH-RESPONSE" => "cmdRefresh" , "VERIFY-CLIENT-ID" => "verifyClient" , "RESYNC" => "resyncData",
                                 "VALUE-SET" => "cmdCompSetValue");
    var $error;
    /**
     * Redirect class to get action, blank
     *
     */
    function indexAction ()
    {
        $response = $this->getResponse();
        $response->setHeader("Content-Type", "text/xml");
        $response->sendHeaders();
        $this->getAction();
    }
    /**
     * Retrives a database object and renders it in xml
     *
     */
    function getAction ()
    {
        $response = $this->getResponse();
        $xmlData = stripslashes(urldecode($_POST["XML"]));
        //echo(">>>>$xmlData<<<<\n");
        if (empty($xmlData))
            $this->generateError(QUERY_ERROR, "No data sent");
        $this->breakDownRequest($xmlData);
    }
    function breakDownRequest ($request_data)
    {
        //$xml = new SimpleXMLElement($request_data);
        //        var_dump($_POST);
        $xml = simplexml_load_string($request_data);
        $requestType = $xml->clientCommand->name;
        $clientVersion = $xml->clientVersion;
        $clientID = $xml->clientID;
        if ($requestType == "")
            $this->generateError(ERROR_QUERY, "Invalid Query");
        if ($clientVersion == "")
            $this->generateError(ERROR_QUERY, "Invalid Query");
        if ($clientID == "" && $requestType != "REGISTER-IN-SERVER")
            $this->generateError(ERROR_QUERY, "Invalid Query");
        if (! array_key_exists("$requestType", $this->requestCommands))
            $this->generateError(ERROR_QUERY, "Invalid query type `$requestType'");
        if (strlen($clientID) != 36 && $requestType != "REGISTER-IN-SERVER")
            $this->generateError(ERROR_QUERY, "Invalid client id `$clientID'");
        if ($this->error == 1)
            return;
        $callBackFunction = $this->requestCommands["$requestType"];
        $procedures = new Custom_XMLProcedures();
        call_user_method($callBackFunction, $procedures, $xml);
    }
    function generateError ($error_type, $error_msg)
    {
        $this->error = 1;
        $XML_SCHEMA = '<commands><serverCommand>
                        <name></name>
                        <statusMsg>
                        </statusMsg>
                        </serverCommand></commands>';
        $xml = new SimpleXMLElement($XML_SCHEMA);
        $xml->serverCommand->name = "$error_type";
        $xml->serverCommand->statusMsg = "$error_msg";
        $this->setOutput($xml->asXML());
    }
    function setOutput ($output)
    {
        return $this->getResponse()->setBody($output);
    }
}