<?php
class Functions {
    public static function checkWritable($file) {
        $writable =is_writeable($file);
        $return = array("file" => "$file", "status" => "unknown", "note" => "none", "mess" => "Writable");
        if ($writable === true) {
            $return['status'] = "ok";
            $return['note'] = 'none';
            $return['mess'] = 'Writeable';
        } else {
            if (@chmod($file, 0777) === true) {
                $return['status'] = 'resolved';
                $return['note'] = "Chmoded \"$file\" to permision 0777";
                $return['mess'] = 'Chmoded';
            } else {
                $return['status'] = 'fail';
                $return['note'] = "Please make \"$file\" writable by typeing \"chmod 0777 ".realpath($file)."\".";
                $return['mess'] = 'Read-Only';
            }
        }
        return $return;
    }
	
	public static function installDatabase($host,$database,$user,$password) {
		$sql = file_get_contents('sql/schema.sql');
		$queries = explode(';', $sql);
		mysql_connect($host, $user, $password) or die(mysql_error());
		mysql_select_db($database)  or die(mysql_error());
		
		foreach ($queries as $query) {
			mysql_query($query);
		}
	}
}

class Pages {

	function __construct() {
		$this->defaults = array(
			"db" => array(
					"host" => "localhost",
					"name" => "titan_backup_business_server",
					"user" => "root",
					"pass"   => ""
			),
			"site" => array(
					"user" => "admin",
					"pass" => "",
					"pass_re" => "",
					"adminEmail" => "",
					
			)
		);
		
		if (isset($_POST['site'])) {
			$this->defaults["site"] = $_POST["site"];
		}
		if (isset($_POST['db'])) {
			$this->defaults["db"] = $_POST["db"];
		}
	}
	
    public function checkPermissions() {
        $requiredFiles = array();
        $requiredFiles[] = array("file" => "../misc/", "message" => "Checking template directory permissions");
        $requiredFiles[] = array("file" => "../config/config.ini", "message" => "Checking config file write permissions");
        $requiredFiles[] = array("file" => "../cron/logs", "message" => "Checking cron log directory permissions");
        $return = "ok";
        echo('<table id="permissions">');
        echo('<tr><th scope="col">Checking PHP Version (5.1.4 Required)</th>');
        $cPhpVersion = phpversion();
        $cmp = version_compare($cPhpVersion, '5.1.4', 'ge');
        if ($cmp === true) {
            echo("<td class=\"ok\">Your PHP version is $cPhpVersion. All is well.</td></tr>");
        } else {
            echo("<td class=\"fail\">Your PHP version is $cPhpVersion. Please upgrade to the latest php version.</td></tr>");  
            $return = "fail";          
        }
        
        foreach ($requiredFiles as $fileData) {
            echo("<tr><th scope=\"col\">$fileData[message]</th>");
            $fileRet = Functions::checkWritable($fileData['file']);
            if ($fileRet['status'] === "fail") { $return = "retry"; }


            echo("<td class=\"$fileRet[status]\">$fileRet[mess]");
            if ($ret['note'] != 'none') {
                echo("<p class=\"note\">$ret[note]</p>");
            }
            echo("</td></tr>");
        }
        echo('</table>');

        if ($return == "ok") {
            echo("<br /><div id=\"buttons\"><form action=\"install.php\" method=\"get\">
            <input type=\"hidden\" name=\"step\" value=\"2\" />
            <input type=\"submit\" class=\"button\" value=\"Next &gt;\" />
            </form></div>
            ");
            $_SESSION['install']['permissions'] = "ok";
        } else {
            echo("<br /><div id=\"buttons\"><form action=\"install.php\" method=\"get\">
            <input type=\"hidden\" name=\"step\" value=\"1\" />
            <input type=\"submit\" class=\"button\" value=\"Retry\" />
            </form></div>
            "); 
            $_SESSION['install']['permissions'] = "error";
        }
        return $return;
    }

    public function setupDatabase() {
        if ($_POST['submit'] == "Save") {
            $error = array();
            $noContinue = false;
            //$error = "Test";
            $_SESSION['install']['databse'] = 'ok';
            $_SESSION['databse'] = $_POST['db'];
            $db = $_POST['db'];

            $connect = @mysql_connect($db['host'], $db['user'], $db['pass']);
            $select = @mysql_select_db($db['name']);

            if (mysql_errno()) $error[] = mysql_error();
            if (sizeof($error) > 0) $noContinue = true;

            if ($noContinue == false) {
                $options = "[database]" . PHP_EOL;
                $options .= "engine = mysql" . PHP_EOL;
                $options .= "host = $db[host]" . PHP_EOL;
                $options .= "user = $db[user]" . PHP_EOL;
                $options .= "pass = $db[pass]" . PHP_EOL;
                $options .= "dbname = $db[name]" . PHP_EOL . PHP_EOL;
				if ($db['create'] == "yes") Functions::installDatabase($db['host'],$db['name'],$db['user'],$db['pass']);
                $fd = @fopen('../config/config.ini', 'w');
                @fwrite($fd, $options);
                @fclose($fd);
                header("Location: install.php?step=3");
                return;
            }
        }
        ?>
<form action="install.php?step=2" method="post">
<table id="databaseSetup">
	<tr>
		<th scope="col" class="error" colspan="2">
        <?php 
        if (sizeof($error) > 0):
        foreach ($error as $error_text):
        ?>
        <?=$error_text?><br />
        <?php 
        endforeach;
        endif;
         ?>
        </th>
	</tr>
	<tr>
		<th scope="col">Database Engine:</th>
		<td><span style="font-weight: bolder">MySQL</span></td>
	</tr>
	<tr>
		<th scope="col">Database Host:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="db[host]" value="<?=$this->defaults["db"]["host"]?>" /></span></td>
	</tr>
	<tr>
		<th scope="col">Database Name:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="db[name]" value="<?=$this->defaults["db"]["name"]?>" /></span></td>
	</tr>
	<tr>
		<th scope="col">Database User:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="db[user]" value="<?=$this->defaults["db"]["user"]?>" /></span></td>
	</tr>
	<tr>
		<th scope="col">Database Password:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="db[pass]" value="<?=$this->defaults["db"]["pass"]?>" /></span></td>
	</tr>
	<tr>
		<th scope="col">Create Database Schema:</th>
		<td><span style="font-weight: bolder"><input type="checkbox"
			name="db[create]" value="yes" checked /></span></td>
	</tr>
	<tr>
		<th scope="col" style="text-align: middle;"><input class="button"
			type="submit" name="submit" value="Save" /></th>
	</tr>
</table>
</form>
<?php
    }

    public function setupSite() {
        if ($_POST['submit'] == "Save") {
            $error = array();
            $noContinue = false;
            //$error = "Test";
            $_SESSION['install']['site'] = 'ok';
            $_SESSION['site'] = $_POST['site'];
            $site = $_POST['site'];
			if ($site['pass'] != $site['pass_re']) {
				$noContinue = true;
				$error[] = "Passwords don't match.";
			}
            if ($noContinue == false) {
                $options = "[site]" . PHP_EOL;
                $options .= "authString = " . md5("$site[user]:$site[pass]") . PHP_EOL;
                $options .= "fullUrl = $site[url]"  . PHP_EOL;
                $options .= "webRoot = $site[webroot]"  . PHP_EOL;
                $options .= "timezone = Europe/Bucharest"  . PHP_EOL;
                $options .= "theme = default"  . PHP_EOL;
                $options .= "lang = $site[lang]"  . PHP_EOL;
				$options .= "adminEmail = $site[adminEmail]" . PHP_EOL;

                $fd = @fopen('../config/config.ini', 'a');
                @fwrite($fd, $options);
                @fclose($fd);
                header("Location: install.php?step=4");
                return;
            }
            $httpdir = str_replace("install/install.php", '', $_SERVER['SCRIPT_NAME']);
        }
        ?>
<form action="install.php?step=3" method="post">
<table id="siteSetup">
	<tr>
		<th scope="col" class="error" colspan="2">
        <?php 
        if (sizeof($error) > 0):
        foreach ($error as $error_text):
        ?>
        <?=$error_text?><br />
        <?php 
        endforeach;
        endif;
         ?>
        </th>
	</tr>
	<tr>
		<th scope="col">Admin User:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="site[user]" value="<?=$this->defaults["site"]["user"]?>" /></span></td>
	</tr>
	<tr>
		<th scope="col">Admin Password:</th>
		<td><span style="font-weight: bolder"><input type="password"
			name="site[pass]" value="" /></span></td>
	</tr>
	<tr>
		<th scope="col">Admin Password Retype:</th>
		<td><span style="font-weight: bolder"><input type="password"
			name="site[pass_re]" value="" /></span></td>
	</tr>
	<tr>
		<th scope="col">Admin E-Mail:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="site[adminEmail]"
			value="<?=$this->defaults["site"]["adminEmail"]?>" /></span></td>
	</tr>
	<tr>
		<th scope="col">Site URL:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="site[url]"
			value="http://<?=$_SERVER["HTTP_HOST"]?>/<?=$httpdir?>" " /></span></td>
	</tr>
	<tr>
		<th scope="col">Web Root:</th>
		<td><span style="font-weight: bolder"><input type="text"
			name="site[webroot]" value="<?=$_SERVER["DOCUMENT_ROOT"]?>" /></span></td>
	</tr>
	<tr>
		<th scope="col">Language:</th>
		<td><span style="font-weight: bolder"> <select name="site[lang]">
			<option value="en">English</option>
		</select> </span></td>
	</tr>
	<tr>
		<th scope="col" style="text-align: middle;"><input class="button"
			type="submit" name="submit" value="Save" /></th>
	</tr>
</table>
</form>
<?php
    }

    public function finishPage() {
	
        ?>
<h1 style="padding-top: 10px">Instalation Finished</h1>
<p style="text-align: center">The installation was successful. <a
	href="../help" target="blank">Click Here</a> to open the Administration
Console.</p>
<p style="color: red; font-weight: bold; text-align: center;">IMPORTANT:
For security reasons we STRONGLY reccomend that you delete the
"/install" directory in your webroot.</p>
<?php
    }

}
?>