DROP TABLE IF EXISTS `cmdqueue`;
CREATE TABLE `cmdqueue` (
  `id` int(11) NOT NULL auto_increment,
  `comp_guid` char(128) NOT NULL,
  `cmd_name` char(20) NOT NULL,
  `status` enum('sended','pending') default 'pending',
  `xml` text,
  `task_id` int(11) default NULL,
  `insert_date` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `computer_variables`;
CREATE TABLE `computer_variables` (
  `id` int(11) NOT NULL auto_increment,
  `comp_guid` varchar(128) default NULL,
  `task_guid` varchar(128) default NULL,
  `var_name` varchar(128) default NULL,
  `value` text,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
DROP TABLE IF EXISTS `computers`;
CREATE TABLE `computers` (
  `comp_guid` char(128) NOT NULL,
  `workgroup` char(128) default NULL,
  `domain` char(128) default NULL,
  `ip` char(128) default NULL,
  `computer_name` char(128) default NULL,
  `status` enum('pending','approved') default 'pending',
  `options` text,
  `last_update` bigint(20) default NULL,
  `client_version` char(10) default NULL,
  `owner_email` varchar(220) default NULL,
  `last_update_notification` bigint(20) default NULL,
  PRIMARY KEY  (`comp_guid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `log_types`;
CREATE TABLE `log_types` (
  `id` int(11) NOT NULL default '0',
  `name` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `log_types` VALUES (0,'Unknown'),(1,'Start - Scheduled'),(2,'Start - Server'),(3,'Start - Client'),(4,'End Report'),(5,'Stop Server'),(6,'Stop Client'),(7,'Restore - Server'),(8,'Restore - Client'),(9,'Restore End Report'),(10,'Missed Report'),(11,'Server Side'),(12,'Sync Start');
DROP TABLE IF EXISTS `logs`;
CREATE TABLE `logs` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `log_type_id` int(11) default NULL,
  `time` datetime default NULL,
  `status` int(11) default NULL,
  `task_id` varchar(130) default NULL,
  `computer_id` varchar(130) default NULL,
  `summary` varchar(200) default NULL,
  `details` text,
  `missed` enum('yes','no') character set latin1 default 'no',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `options`;
CREATE TABLE `options` (
  `option_key` varchar(255) NOT NULL default '',
  `option_value` text,
  PRIMARY KEY  (`option_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `rules`;
CREATE TABLE `rules` (
  `rule_id` int(11) NOT NULL auto_increment,
  `workgroup_match` text,
  `domain_match` text,
  `computer_match` text,
  `ip_match` text,
  `user_match` text,
  `task_id` int(11) NOT NULL,
  PRIMARY KEY  (`rule_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `task_history`;
CREATE TABLE `task_history` (
  `hist_id` int(11) NOT NULL auto_increment,
  `task_id` int(11) NOT NULL,
  `data` text NOT NULL,
  `insert_date` bigint(9) NOT NULL,
  `type` enum('Original','Edit','Current') character set latin1 default 'Edit',
  PRIMARY KEY  (`hist_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `task_status`;
CREATE TABLE `task_status` (
  `task_guid` char(40) default NULL,
  `computer_guid` char(40) default NULL,
  `task_status` varchar(50) default NULL,
  `task_progress` int(11) default NULL,
  `sid` int(11) NOT NULL auto_increment,
  `last_completed_time` varchar(255) default 'Never.',
  `last_run_time` varchar(255) default 'Never.',
  `next_run_time` varchar(255) default 'Never.',
  `update_time` timestamp NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `missed` enum('yes','no') character set latin1 default 'no',
  `rescheduled` enum('yes','no') character set latin1 default 'no',
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `tasks`;
CREATE TABLE `tasks` (
  `id` int(11) NOT NULL auto_increment,
  `guid` char(128) NOT NULL,
  `user_id` int(11) default '0',
  `data` longtext NOT NULL,
  `data_md5` char(32) NOT NULL,
  `task_name` char(128) NOT NULL,
  `last_run_time` varchar(255) default 'Never.',
  `last_completed_time` varchar(255) default 'Never.',
  `next_run_time` varchar(255) default 'Never.',
  `task_percentage` int(11) default '0',
  `task_status` varchar(40) default 'Stopped',
  `admin_task` enum('Yes','No') character set latin1 default 'No',
  `owner` varchar(255) default NULL,
  `task_type` varchar(100) default NULL,
  `task_hidden` enum('Yes','No') default 'Yes',
  `up_status` enum('send','modified','delete','ok') default 'send',
  `create_date` bigint(20) default NULL,
  `update_time` timestamp NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `store_path` varchar(80) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `taskGuid` (`guid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(20) NOT NULL,
  `computer_id` char(128) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
