<?php
class Custom_XMLSchemas
{
    const XML_RESPONSE_START = "<?xml version='1.0' ?>\n\n<commands><serverVersion>1.0</serverVersion>";
    const XML_RESPONSE_END = "</commands>";
    const XML_RESPONSE_REGISTER_OK = "<serverCommand><name>REGISTER-RESPONSE</name><status>OK</status><statusMSG>Registered into database, pending aproval</statusMSG></serverCommand>";
    const XML_RESPONSE_REGISTER_FAIL = "<serverCommand><name>REGISTER-RESPONSE</name><status>ERROR</status><statusMSG>ErrorMessage HERE</statusMSG></serverCommand>";
    const XML_RESPONSE_NO_COMMAND = "<commands><serverCommand><name>NO-COMMAND</name></serverCommand></commands>";
    const XML_RESPONSE_OK = "<serverCommand><name>OK</name></serverCommand>";
    //    const XML_RESPONSE_REFRESH = "<serverCommand><name>REFRESH</name></serverCommand>";
    const XML_RESPONSE_UPDATE = "<serverCommand><name>PROGRAM-UPDATE</name></serverCommand>";
    const XML_RESPONSE_PROGRAM_OPTIONS = "<serverCommand><name>PROGRAM-OPTIONS</name><options></options></serverCommand>";
    const XML_RESPONSE_ADMIN_TASK_NEW = "<serverCommand><name>ADMIN-TASK-NEW</name><tasks><task><taskName></taskName><taskData></taskData></task></tasks></serverCommand>";
    const XML_RESPONSE_REFRESH = "<serverCommand><name>REFRESH</name><tasks><task><taskName></taskName><taskData></taskData></task></tasks></serverCommand>";
    const XML_RESPONSE_ADMIN_TASK_EDIT = "<serverCommand><name>ADMIN-TASK-EDIT</name><tasks><task><taskName></taskName><taskData></taskData></task></tasks></serverCommand>";
    const XML_RESPONSE_ADMIN_TASK_DELETE = "<serverCommand><name>ADMIN-TASK-DELETE</name><tasks><task><taskName></taskName></task></tasks></serverCommand>";
    const XML_RESPONSE_TASK_START = "<serverCommand><name>TASK-START</name><tasks><task><taskName></taskName></task></tasks></serverCommand>";
    const XML_RESPONSE_TASK_STOP = "<serverCommand><name>TASK-STOP</name><tasks><task><taskName></taskName></task></tasks></serverCommand>";
    const XML_RESPONSE_TASK_RESTORE = "<serverCommand><name>TASK-RESTORE</name><tasks><task><taskName>Task name</taskName></task></tasks></serverCommand>";
    static function getSchema ($schema)
    {
        $string = self::XML_RESPONSE_START . self::XML_RESPONSE_END;
        $xml = simplexml_load_string($string);
        $xml->addChild('serverCommand', $schema);
        $xml->serverCommand->serverVersion = "1.1";
        return $xml->asXML();
    }
    static function getCommand ($schema)
    {
        //$string = $schema;
        return $schema;
    }
    /**
     * Grabs the commands header
     *
     * @return SimpleXMLElement
     */
    static function getHeader ()
    {
        $string = self::XML_RESPONSE_START . self::XML_RESPONSE_END;
        return new SimpleXMLElement($string);
    }
    static function simplexml_append (SimpleXMLElement $parent, SimpleXMLElement $new_child)
    {
        $node1 = dom_import_simplexml($parent);
        $dom_sxe = dom_import_simplexml($new_child);
        $node2 = $node1->ownerDocument->importNode($dom_sxe, true);
        $newRow = $node1->appendChild($node2);
    }
}